# std::auto_ptr< Type > Class Template Reference

A simple smart pointer providing strict ownership semantics. More...

List of all members.

## Public Types

typedef Type | element_type
| The pointed-to type.

## Public Member Functions

| auto_ptr (element_type *__p=0) throw ()
| An auto_ptr is usually constructed from a raw pointer.
| auto_ptr (auto_ptr &a) throw ()
| An auto_ptr can be constructed from another auto_ptr.
template<typename Type1> | auto_ptr (auto_ptr< Type1 > &a) throw ()
| An auto_ptr can be constructed from another auto_ptr.
auto_ptr & | operator= (auto_ptr &a) throw ()
| auto_ptr assignment operator.
template<typename Type1> auto_ptr & | operator= (auto_ptr< Type1 > &a) throw ()
| auto_ptr assignment operator.

## Detailed Description

### template<typename Type>
class std::auto_ptr< Type >

A simple smart pointer providing strict ownership semantics.

The Standard says:

      An auto_ptr owns the object it holds a pointer to.  Copying
      an auto_ptr copies the pointer and transfers ownership to the
      destination.  If more than one auto_ptr owns the same object
      at the same time the behavior of the program is undefined.

      The uses of auto_ptr include providing temporary
      exception-safety for dynamically allocated memory, passing
      ownership of dynamically allocated memory to a function, and
      returning dynamically allocated memory from a function.  auto_ptr does not meet the CopyConstructible and Assignable
      requirements for Standard Library container elements and thus
      instantiating a Standard Library container with an auto_ptr results in undefined behavior.

Quoted from [20.4.5]/3.

Good examples of what can and cannot be done with auto_ptr can be found in the libstdc++ testsuite.

Definition at line 173 of file memory.

## Member Typedef Documentation

template<typename Type>
typedef Type std::auto_ptr< Type >::element_type

| The pointed-to type. Definition at line 180 of file memory.

## Constructor & Destructor Documentation

template<typename Type>
std::auto_ptr< Type >::auto_ptr | ( | element_type * | __p = `0` | ) | throw ()`[inline, explicit]`

An auto_ptr is usually constructed from a raw pointer.

Parameters:

  | p | A pointer (defaults to NULL).

This object now owns the object pointed to by p.

Definition at line 189 of file memory.

template<typename Type>
std::auto_ptr< Type >::auto_ptr | ( | auto_ptr< Type > & | a | ) | throw ()`[inline]`

An auto_ptr can be constructed from another auto_ptr.

Parameters:

  | a | Another auto_ptr of the same type.

This object now owns the object previously owned by a, which has given up ownsership.

Definition at line 198 of file memory.

template<typename Type>
template<typename Type1>
std::auto_ptr< Type >::auto_ptr | ( | auto_ptr< Type1 > & | a | ) | throw ()`[inline]`

An auto_ptr can be constructed from another auto_ptr.

Parameters:

  | a | Another auto_ptr of a different but related type.

A pointer-to-Tp1 must be convertible to a pointer-to-Tp/element_type.

This object now owns the object previously owned by a, which has given up ownsership.

Definition at line 211 of file memory.

## Member Function Documentation

template<typename Type>
template<typename Type1>
auto_ptr& std::auto_ptr< Type >::operator= | ( | auto_ptr< Type1 > & | a | ) | throw ()`[inline]`

auto_ptr assignment operator.

Parameters:

  | a | Another auto_ptr of a different but related type.

A pointer-to-Tp1 must be convertible to a pointer-to-Tp/element_type.

This object now owns the object previously owned by a, which has given up ownsership. The object that this one used to own and track has been deleted.

Definition at line 240 of file memory.

References std::auto_ptr< Type >::operator=().

template<typename Type>
auto_ptr& std::auto_ptr< Type >::operator= | ( | auto_ptr< Type > & | a | ) | throw ()`[inline]`

auto_ptr assignment operator.

Parameters:

  | a | Another auto_ptr of the same type.

This object now owns the object previously owned by a, which has given up ownsership. The object that this one used to own and track has been deleted.

Definition at line 222 of file memory.

References std::auto_ptr< Type >::operator=().

Referenced by std::auto_ptr< Type >::operator=().

The documentation for this class was generated from the following file:

- memory